
' .ApplicationSource CRV-Painter(1.0)'!

'From VisualWorks(R), Release 2.5 of September 26, 1995 on August 22, 1997 at 3:11:49 pm'!

'- user-strings of CRV-Painter(1.0) -'!

#('name' 'CRV-Painter' 'version' '1.0')!

'required applications for CRV-Painter(1.0)'!

Message
	selector: #checkRequired:
	argument: #()!

'- source of CRV-Painter(1.0) -'!



View subclass: #PathView
	instanceVariableNames: 'radius grid curveNr index dragMode bgBitmap showControlPolygon showControlLabels showGrid showBg '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CurvePainter'!

!PathView methodsFor: 'initialize-release'!

initialize

	super initialize.
	radius := 3.
	grid := 25.
	curveNr := 1.
	self unselectControlPoint.
	dragMode := false.
	showControlPolygon := true.
	showControlLabels := true.
	showGrid := true.
	showBg := true.! !

!PathView methodsFor: 'accessing'!

bgBitmap

	^bgBitmap!

bgBitmap: anImage

	bgBitmap  :=  anImage.
	self invalidate!

curveNr

	^curveNr!

curveNr: aNumber

	(curveNr = aNumber or: [aNumber < 1 or: [aNumber > self model listOfCurves size]])
		ifFalse: [
			curveNr := aNumber.
			self invalidate.
		].!

grid

	^grid!

index

	^index!

showBg

	^showBg!

showBg: aBoolean

	showBg = aBoolean ifFalse: [
		showBg := aBoolean.
		self invalidate.
	].!

showControlLabels

	^showControlLabels!

showControlLabels: aBoolean

	showControlLabels = aBoolean ifFalse: [
		showControlLabels := aBoolean.
		self invalidate.
	].!

showControlPolygon

	^showControlPolygon!

showControlPolygon: aBoolean

	showControlPolygon = aBoolean ifFalse: [
		showControlPolygon := aBoolean.
		self invalidate.
	].!

showGrid

	^showGrid!

showGrid: aBoolean

	showGrid = aBoolean ifFalse: [
		showGrid := aBoolean.
		self invalidate.
	].! !

!PathView methodsFor: 'controller accessing'!

defaultControllerClass

	^PathController! !

!PathView methodsFor: 'displaying'!

displayBackgroundOn: aGraphicsContext

	self bgBitmap notNil ifTrue: [
		"speedup the displayImage"
		bgBitmap := aGraphicsContext paintPolicy
			representImage: self bgBitmap
			forMedium: aGraphicsContext medium.
		self bgBitmap displayOn: aGraphicsContext
	]!

displayOn: aGraphicsContext

	Cursor wait showWhile: [
		"(Circle center: 250@250 radius: 250) displayStrokedOn: aGraphicsContext."
		showBg ifTrue: [	self displayBackgroundOn: aGraphicsContext].
		showGrid ifTrue: [self drawGridOn: aGraphicsContext].
		showControlPolygon ifTrue: [self drawControlPolygonOn: aGraphicsContext].
		(dragMode not or: [InputState default shiftDown]) ifTrue: [
			self model displayPathOn: aGraphicsContext.
		].
		self drawControlPointsOn: aGraphicsContext.
	]!

drawControlPointsOn: aGraphicsContext

	self currentCurve controlPoints keysAndValuesDo: [ :i :cp |
		aGraphicsContext paint:
			(i = index ifTrue: [ColorValue red] ifFalse: [ColorValue royalBlue]).
		self drawMarkerOn: aGraphicsContext at: cp label: i
	].!

drawControlPolygonOn: aGraphicsContext

	| crv controlPoints |

	crv :=self currentCurve.
	controlPoints := crv controlPoints.

	aGraphicsContext
		paint: ColorValue lightGray;
		displayPolyline: controlPoints.

	crv cyclic ifTrue: [
		aGraphicsContext
			displayLineFrom: controlPoints last
			to: controlPoints first
	].!

drawGridOn: aGraphicsContext

	| extent |

	aGraphicsContext paint: ColorValue gray.
	extent := self bounds extent.
	grid to: extent y by: grid do: [ :y |
		grid to: extent x by: grid do: [ :x |
			aGraphicsContext
				displayRectangle: (Rectangle origin: 0@0 corner: 1@1) at: x@y
		].
	].!

drawMarkerOn: aGraphicsContext at: coordinates label: anObject

	(Circle center: coordinates radius: radius) displayFilledOn: aGraphicsContext.
	(showControlLabels and: [anObject notNil]) ifTrue: [
		aGraphicsContext displayString: anObject printString at: 1@-1 * radius + coordinates
	].! !

!PathView methodsFor: 'background image'!

deleteBackground

	self bgBitmap: nil!

loadBackground

	| fileName image |

	fileName := Dialog
				requestFileName: 'Name a file'
				default: '*.gif'
				version: #mustBeOld
				ifFail: [nil].
	fileName isNil ifFalse: [
		image := GIFReadWriter imageFromFileNamed: fileName.
		self bgBitmap: image]! !

!PathView methodsFor: 'save txt / print eps'!

printEpsOn: aPostScriptFile

	self model displayPathOn: aPostScriptFile graphicsContext! !

!PathView methodsFor: 'private'!

currentCurve

	^self model listOfCurves at: curveNr!

dragModeOff

	dragMode := false.
	self model style outputParameters quality: OutputParameters qualityNormal.!

dragModeOn

	dragMode := true.
	self model style outputParameters quality: OutputParameters qualityDraft.!

selectControlPointNear: aPoint

	self currentCurve controlPoints keysAndValuesDo: [:i :p |
		(p dist: aPoint) <= radius ifTrue: [index := i. ^nil]
	].
	self unselectControlPoint.
	^nil!

selectCurveNear: aPoint

	| minDist minValue minNr pOld pNew p dist |

	minDist := 10.0.
	minValue := minDist. minNr := curveNr.
	self model listOfCurves keysAndValuesDo: [ :nr :crv |
		pOld := crv controlPoints first.
		2 to: crv controlPoints size do: [ :i |
			pNew := crv controlPoints at: i.
			p := aPoint nearestPointOnLineFrom: pOld to: pNew.
			((((Rectangle vertex: pOld vertex: pNew) expandedBy: 1) containsPoint: p) and:
				[(dist := aPoint dist: p) < minValue])
					ifTrue: [minValue := dist. minNr := nr].
			pOld := pNew.
		].
	].
	self curveNr: minNr.
	^nil!

unselectControlPoint

	index := nil.! !

ControllerWithMenu subclass: #CurvePainterController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CurvePainter'!

!CurvePainterController methodsFor: 'initialize-release'!

initialize

	super initialize.
	self menuHolder: self class yellowButtonMenu asValue.! !

!CurvePainterController methodsFor: 'menu messages'!

cmEditStyle

	(self model style respondsTo: #edit) ifTrue: [self model style edit]!

cmInspect

	self model inspect!

cmLoadStyle

	self model loadStyle!

cmLoadStyleCatalog

	self model loadStyleCatalog!

cmPrintEps

	self view printEps!

cmUpdate

	self model changed! !

!CurvePainterController class methodsFor: 'resources'!

yellowButtonMenu
	"UIMenuEditor new openOnClass: self andSelector: #yellowButtonMenu"

	<resource: #menu>
	^#(#Menu #(
			#(#MenuItem 
				#rawLabel: 'load style...' 
				#value: #cmLoadStyle ) 
			#(#MenuItem 
				#rawLabel: 'load style catalog...' 
				#value: #cmLoadStyleCatalog ) 
			#(#MenuItem 
				#rawLabel: 'edit style...' 
				#value: #cmEditStyle ) 
			#(#MenuItem 
				#rawLabel: 'print PS/EPS...' 
				#value: #cmPrintEps ) 
			#(#MenuItem 
				#rawLabel: 'inspect' 
				#value: #cmInspect ) 
			#(#MenuItem 
				#rawLabel: 'update' 
				#value: #cmUpdate ) ) #(3 1 2 ) nil ) decodeAsLiteralArray! !

View subclass: #CurvePainterView
	instanceVariableNames: 'updateProcess '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CurvePainter'!

!CurvePainterView methodsFor: 'initialize-release'!

release

	self checkProcess.
	self model release.
	super release.! !

!CurvePainterView methodsFor: 'displaying'!

displayOn: aGraphicsContext

	"self checkProcess.
	updateProcess :=
		[self model displayPathStyleOn: aGraphicsContext]
			forkAt: Processor userSchedulingPriority"
	Cursor wait showWhile: [self model displayPathStyleOn: aGraphicsContext]! !

!CurvePainterView methodsFor: 'controller accessing'!

defaultControllerClass

	^CurvePainterController! !

!CurvePainterView methodsFor: 'save txt / print eps'!

printEpsOn: aPostScriptFile

	self model displayPathStyleOn: aPostScriptFile graphicsContext! !

!CurvePainterView methodsFor: 'private'!

checkProcess

	updateProcess notNil ifTrue: [updateProcess terminate]! !

ControllerWithMenu subclass: #PathController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CurvePainter'!

!PathController methodsFor: 'initialize-release'!

initialize

	| yellowButtonMenu |

	super initialize.

	yellowButtonMenu := self class yellowButtonMenu.
	(yellowButtonMenu menuItemLabeled: 'cyclic')
		indication: [self currentCurve cyclic].
	(yellowButtonMenu menuItemLabeled: 'control polygon')
		indication: [self view showControlPolygon].
	(yellowButtonMenu menuItemLabeled: 'control labels')
		indication: [self view showControlLabels].
	(yellowButtonMenu menuItemLabeled: 'grid')
		indication: [self view showGrid].
	(yellowButtonMenu menuItemLabeled: 'background')
		indication: [self view showBg].

	self menuHolder: yellowButtonMenu asValue.! !

!PathController methodsFor: 'control defaults'!

doubleClickAt: pt

	self view selectControlPointNear: pt.
	self view index notNil ifTrue: [
		self view invalidate.
		(self currentCurve controlPoints at: self view index) edit.
		self view unselectControlPoint.
		self currentCurve markDirty.
		self model changed.
	]!

redButtonActivity
	"ControlPointDrag"

	| pOld pNew |
	
	pOld := self sensor cursorPoint.
	self view selectControlPointNear: pOld.
	self view index = nil
		ifTrue: [
			self view selectCurveNear: pOld.
			[self poll. self sensor redButtonPressed] whileTrue.
		]
		ifFalse: [ "move cursor at least 2 pixel before activate dragmode"
			[self poll. self sensor redButtonPressed and:
				[(pOld dist: self sensor cursorPoint) < 2.0]] whileTrue.
			self sensor redButtonPressed ifTrue: [
				self view dragModeOn.
				self redButtonDragWhileTrue: [:p |
					pNew := InputState default ctrlDown
						ifTrue: [p roundTo: self view grid]
						ifFalse: [p].
					pOld ~= pNew ifTrue: [
						pOld := pNew.
						self view index notNil ifTrue: [ "avoid trouble with doubleClick"
							(self currentCurve controlPoints at: self view index) coordinates: pNew.
							InputState default shiftDown
								ifTrue: [self currentCurve markDirty. self model changed.]
								ifFalse: [self view invalidate]
						].
					].
				].
				self view unselectControlPoint.
				self view dragModeOff. "the model will changed"
				self currentCurve markDirty.
				self model changed.
			].
		].! !

!PathController methodsFor: 'broadcast'!

downcastLocalEvent: aKey with: aParameter at: aPoint from: anInitiator 
	"This is a message passed down the view structure to some single 
	part. Answer true if we accepted the event, or false if it should be 
	passed on to whatever's behind us."

	aKey == #doubleClick
		ifTrue: [self doubleClickAt: aPoint.
				^true].
	^super downcastLocalEvent: aKey with: aParameter at: aPoint from: anInitiator! !

!PathController methodsFor: 'menu messages'!

cmDelete

	self model listOfCurves remove: self currentCurve.
	self view curveNr: 1.
	self model changed.!

cmDeleteBackground

	self view deleteBackground!

cmFlipBg

	self view showBg: self view showBg not!

cmFlipControlLabels

	self view showControlLabels: self view showControlLabels not!

cmFlipControlPolygon

	self view showControlPolygon: self view showControlPolygon not!

cmFlipCyclic

	self currentCurve cyclic: self currentCurve cyclic not.
	self model changed.!

cmFlipGrid

	self view showGrid: self view showGrid not!

cmFromUserAdd

	| crv |

	crv := self fromUser.
	crv notNil ifTrue: [self model listOfCurves add: crv. self model changed]!

cmFromUserReplace

	| crv |

	crv := self fromUser.
	crv notNil ifTrue: [
		self model listOfCurves
			at: (self model listOfCurves find: self currentCurve)
			put: crv.
		self model changed.
	]!

cmInspect

	self model inspect!

cmInspectCurrentCurve

	self currentCurve inspect!

cmInterpolationBSpline

	self currentCurve interpolation: #bSpline.
	self model changed.!

cmInterpolationCatmull

	self currentCurve interpolation: #catmull.
	self model changed.!

cmInterpolationChordal

	self currentCurve interpolation: #chordal.
	self model changed.!

cmInterpolationPolyline

	self currentCurve interpolation: #polyline.
	self model changed.!

cmLoad

	| curves |

	(curves := CurvePainter loadTxt) notNil ifTrue: [
		self model listOfCurves: curves listOfCurves.
		self view curveNr: 1.
		self model changed.
	].!

cmLoadBackground

	self view loadBackground!

cmPrintEps

	self view printEps!

cmReverse

	self currentCurve controlPoints: self currentCurve controlPoints reverse.
	self model changed.!

cmSave

	self model saveTxt!

cmSnapAllToGrid

	self currentCurve verticesDo: [ :cp |
		cp coordinates: (cp coordinates roundTo: self view grid)
	].
	self currentCurve markDirty.
	self model changed.!

cmUpdate

	self model changed! !

!PathController methodsFor: 'private'!

currentCurve

	^self model listOfCurves at: self view curveNr!

fromUser

	| gc sen points p |

	Cursor crossHair showWhile: [
		gc := self view graphicsContext.
		gc flush.
		sen := self sensor.
		points := OrderedCollection new.
		[	sen waitButton.
			p := sen mousePoint.
			InputState default ctrlDown ifTrue: [p := p roundTo: self view grid].
			sen redButtonPressed.] whileTrue: [
			sen waitNoButton.
			points add: (ControlPoint coordinates: p).
			self view drawMarkerOn: gc at: p label: points size.
			self checkForEvents.
		]
	].
	points size = 2 ifTrue: [^Path controlPoints: points interpolation: #polyline].
	points size > 1 ifTrue: [^Path controlPoints: points].
	^nil! !

!PathController class methodsFor: 'resources'!

yellowButtonMenu
	"UIMenuEditor new openOnClass: self andSelector: #yellowButtonMenu"

	<resource: #menu>
	^#(#Menu #(
			#(#MenuItem 
				#rawLabel: 'interpolation' 
				#submenu: #(#Menu #(
						#(#MenuItem 
							#rawLabel: 'b-spline' 
							#value: #cmInterpolationBSpline ) 
						#(#MenuItem 
							#rawLabel: 'catmull' 
							#value: #cmInterpolationCatmull ) 
						#(#MenuItem 
							#rawLabel: 'polyline' 
							#value: #cmInterpolationPolyline ) 
						#(#MenuItem 
							#rawLabel: 'chordal' 
							#value: #cmInterpolationChordal ) ) #(4 ) nil ) ) 
			#(#MenuItem 
				#rawLabel: 'cyclic' 
				#value: #cmFlipCyclic ) 
			#(#MenuItem 
				#rawLabel: 'snap all to grid' 
				#submenu: #(#Menu #(
						#(#MenuItem 
							#rawLabel: 'confirm' 
							#value: #cmSnapAllToGrid ) ) #(1 ) nil ) ) 
			#(#MenuItem 
				#rawLabel: 'reverse' 
				#value: #cmReverse ) 
			#(#MenuItem 
				#rawLabel: 'add from user' 
				#value: #cmFromUserAdd ) 
			#(#MenuItem 
				#rawLabel: 'replace from user' 
				#value: #cmFromUserReplace ) 
			#(#MenuItem 
				#rawLabel: 'delete' 
				#submenu: #(#Menu #(
						#(#MenuItem 
							#rawLabel: 'confirm' 
							#value: #cmDelete ) ) #(1 ) nil ) ) 
			#(#MenuItem 
				#rawLabel: 'load...' 
				#value: #cmLoad ) 
			#(#MenuItem 
				#rawLabel: 'save as...' 
				#value: #cmSave ) 
			#(#MenuItem 
				#rawLabel: 'print PS/EPS...' 
				#value: #cmPrintEps ) 
			#(#MenuItem 
				#rawLabel: 'load background...' 
				#value: #cmLoadBackground ) 
			#(#MenuItem 
				#rawLabel: 'delete background' 
				#submenu: #(#Menu #(
						#(#MenuItem 
							#rawLabel: 'confirm' 
							#value: #cmDeleteBackground ) ) #(1 ) nil ) ) 
			#(#MenuItem 
				#rawLabel: 'control polygon' 
				#value: #cmFlipControlPolygon ) 
			#(#MenuItem 
				#rawLabel: 'control labels' 
				#value: #cmFlipControlLabels ) 
			#(#MenuItem 
				#rawLabel: 'grid' 
				#value: #cmFlipGrid ) 
			#(#MenuItem 
				#rawLabel: 'background' 
				#value: #cmFlipBg ) 
			#(#MenuItem 
				#rawLabel: 'inspect' 
				#value: #cmInspect ) 
			#(#MenuItem 
				#rawLabel: 'inspect current path' 
				#value: #cmInspectCurrentCurve ) 
			#(#MenuItem 
				#rawLabel: 'update' 
				#value: #cmUpdate ) ) #(7 3 2 4 3 ) nil ) decodeAsLiteralArray! !

ExternalLanguageParser subclass: #CurvePainterParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CurvePainter'!

!CurvePainterParser methodsFor: 'parsing'!

boolean =

	( ( word=#true | word=#yes | word=#on )	[true] )
	| ( ( word=#false | word=#no | word=#off )	[false] )!

colorDef =

	( keyword=#color: colorValueDef )
	|						[ColorValue black] "default"!

colorValueDef =

	${ number number number $}

	[makeColorValueRed:green:blue:]!

curve =

	pointDef
	pressureDef
	saturationDef
	packageDef
	typeDef
	colorDef

	[makeCurvePoints:interpolation:cyclic:pressure:saturation:package:type:color:]!

curvePainter =

	word=#Path ${ curve+ $}		[makeCurves:]!

interpolation1DDef =

	word=#Interpolation1D

	( (keyword=#keys: ${ number+ $})
	|								[nil] ) "no keys"

	keyword=#values: ${ number+ $}

	( ( keyword=#interpolation:
	( word=#linear1					[Interpolation linear1]
	| word=#bSpline3				[Interpolation bSpline3]
	| word=#catmull3				[Interpolation catmull3]
	| word=#chordal3				[Interpolation chordal3] ) )
	|								[Interpolation linear1] ) "default"

	( ( keyword=#cyclic: boolean )
	|								[false]) "default"

	[makeInterpolation1Dkeys:values:interpolation:cyclic:]!

packageDef =

	( keyword=#package:
	(word |
	word=#nil				[nil]) )
	|						[nil] "default"!

point =

	keyword=#x: signedNumber
	keyword=#y: signedNumber
	( keyword=#w: signedNumber
	|						[1.0] )
	( keyword=#p: number
	|						[1.0] )
	( keyword=#s: number
	|						[1.0] )

	[makePointX:y:w:p:s:]!

pointDef =

	keyword=#points: ${ point+ $}
	
	( ( keyword=#interpolation:
	( word=#bSpline			[#bSpline]
	| word=#catmull				[#catmull]
	| word=#chordal				[#chordal]
	| word=#polyline			[#polyline] ) )
	|							[#chordal] ) "default"

	( ( keyword=#cyclic: boolean )
	|							[false] ) "default"!

pressureDef =

	( keyword=#pressure:
	( interpolation1DDef
	| number)
	|						[nil] ) "default"!

saturationDef =

	( keyword=#saturation:
	( interpolation1DDef	
	| number)
	|						[nil] ) "default"!

typeDef =

	( keyword=#type:
	(word
	| word=#nil				[nil]) )
	|						[nil] "default"! !

!CurvePainterParser methodsFor: 'private parsing support'!

makeColorValueRed: r green: g blue: b

	^ColorValue red: r green: g blue: b!

makeCurvePoints: cp interpolation: i cyclic: c pressure: p saturation: s package: pa type: t color: co

	^(Path controlPoints: cp interpolation: i cyclic: c)
		pressure: p;
		saturation: s;
		package: pa;
		type: t;
		color: co!

makeCurves: listOfCurves

	^CurvePainter listOfCurves: listOfCurves!

makeInterpolation1Dkeys: k values: v interpolation: i cyclic: c

	^k isNil
		ifTrue: [Interpolation1D values: v interpolation: i cyclic: c]
		ifFalse: [Interpolation1D keys: k values: v interpolation: i cyclic: c]!

makePointX: x y: y w: w p: p s: s

	^ControlPoint coordinates: x@y weight: w pressure: p saturation: s! !

!CurvePainterParser class methodsFor: 'class initialization'!

initialize
	"CurvesParser initialize"

	(self organization listAtCategoryNamed: #parsing) do: [ :selector |
		self recompile: selector
	].! !

Object subclass: #CurvePainter
	instanceVariableNames: 'listOfCurves style '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CurvePainter'!

!CurvePainter methodsFor: 'initialize-release'!

release

	self style removeDependent: self.
	super release! !

!CurvePainter methodsFor: 'accessing'!

listOfCurves

	^listOfCurves!

listOfCurves: aCurves

	listOfCurves := aCurves asOrderedCollection.
	self changed.!

style

	^style!

style: aCurves

	(self style == aCurves) ifFalse: [
		self style notNil ifTrue: [
			self style removeDependent: self; closeAllWindows.
		].
		style := aCurves.
		self style addDependent: self.
	].
	self changed! !

!CurvePainter methodsFor: 'diplaying'!

displayPathOn: aGraphicsContext

	self listOfCurves do: [ :p | self style displayPath: p on: aGraphicsContext]!

displayPathStyleOn: aGraphicsContext

	self listOfCurves do: [ :p | self style displayCurve: p on: aGraphicsContext]! !

!CurvePainter methodsFor: 'save txt / print eps'!

loadStyle

	self loadStyle: Style defaultTxtPath, Style defaultTxtName!

loadStyle: aString

	| st |

	(st := Style loadTxt: aString) notNil ifTrue: [self style: st]!

loadStyleCatalog

	self loadStyleCatalog: StyleCatalog defaultTxtPath, StyleCatalog defaultTxtName!

loadStyleCatalog: aString

	| st |

	(st := StyleCatalog loadTxt: aString) notNil ifTrue: [self style: st]!

saveTxtOn: aStream
	"save self in a special TXT-format"

	aStream nextPutAll: 'Path {'; cr.
	self listOfCurves do: [ :crv | crv saveTxtOn: aStream].
	aStream nextPut: $}; cr! !

!CurvePainter methodsFor: 'enumerating'!

verticesDo: aBlock
	"Evaluate the supplied block for every vertex in the receiver."

	self listOfCurves do: [ :crv | crv verticesDo: aBlock]! !

!CurvePainter methodsFor: 'updating'!

update: anAspectSymbol 

	self changed.
	super update: anAspectSymbol .! !

!CurvePainter methodsFor: 'dependents access'!

removeDependent: anObject
	"Remove the argument, anObject, as one of the receiver's dependents."

	super removeDependent: anObject.
	self dependents isEmpty ifTrue: [self style removeDependent: self].
	^anObject! !

!CurvePainter class methodsFor: 'instance creation'!

listOfCurves: aListOfCurves

	^self new listOfCurves: aListOfCurves!

new

	^super new initialize!

style: aStyle

	^self new style: aStyle! !

!CurvePainter class methodsFor: 'load txt'!

loadTxtOn: aStream
	"load from a special TXT-format"

	^(CurvePainterParser parse: aStream nextChunk as: #curvePainter) at: 1! !

!CurvePainter class methodsFor: 'examples'!

example
	"CurvePainter example"

	| curvePainter |

	curvePainter := self loadTxt: self defaultTxtPath, 'path_ex.crv'.

	ScheduledWindow new
		"damageRepairPolicy: DoubleBufferingWindowDisplayPolicy new;"
		label: 'Path';
		minimumSize: 400@300;
		component: (PathView model: curvePainter);
		background: ColorValue white;
		open.

	curvePainter loadStyle: Style defaultTxtPath, 'style01c.crv'.

	ScheduledWindow new
		"damageRepairPolicy: DoubleBufferingWindowDisplayPolicy new;"
		label: 'CurvePainter View';
		minimumSize: 400@300;
		component: (CurvePainterView model: curvePainter);
		background: ColorValue white;
		open.
	
	^curvePainter! !

CurvePainterParser initialize!


